
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//__________________________________________________________________________//
//																									 //
//AUTHOR:	MARCEL KLEE ALIAS "BONECRACKER"											 //
//DATE:		07/11/2007																		 //
//__________________________________________________________________________//
//																									 //
//VERSION 1.0																					 //
//__________________________________________________________________________//
//																									 //
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////





//////////////////////////////////////////////////////////////////////////////

// entry: Bildschirmauflsung
// help: Mgliche Werte: 1 bis 11
// help: Defeniert die Bildschirmauflsung.
var video_mode = 9.0;
// entry: Viedo Depth
// help: Mgliche Werte: 8/16/32
var video_depth = 32; 
var video_screen = 1; 
var d3d_lightres = 1; // Higher resolution for the dynamic lights

// entry: maximale Bilder pro Sekunde
// help: Legt die maximale Bildwiederholungsrate pro Sekunde fest
var fps_max = 60;
// entry: maximale Bilder pro Sekunde
// help: Legt die minimale Bildwiederholungsrate pro Sekunde fest
var fps_min = 7;
var fps_lock = ON;

var time_smooth = 0.50;
var max_lights = 25;
var sun_light = 1;
var shadow_offset = 2.5;
var shadow_stencil = on;

var floor_range = 1000;
var tex_share = 1;

var mouse_pointer = 0;
var d3d_anisotropy = 1;
var d3d_vsync = 1;
var mip_flat = 1.5;
var mip_shaded = 1.0;



//////////////////////////////////////////////////////////////////////////////

path "F:\\Programme\\Programmierung\\A6\\template_6";	// Path to A6 templates directory
path "F:\\Programme\\Programmierung\\A6\\template_6\\code"; // Path to A6 template code subdirectory
path "F:\\Programme\\Programmierung\\A6\\template_6\\code\\PONG";	// Path to A6 template code subdirectory
path "F:\\Programme\\Programmierung\\A6\\template_6\\images\\PONG";	// Path to A6 template image subdirectory
path "F:\\Programme\\Programmierung\\A6\\template_6\\sounds\\PONG";	// Path to A6 template sound subdirectory
path "F:\\Programme\\Programmierung\\A6\\template_6\\models\\PONG";	// Path to A6 template model subdirectory


//path "F:\\Programme\\Programmierung\\A6\\template_6";	// Path to A6 templates directory
//path "F:\\Programme\\Programmierung\\A6\\template_6\\code";	// Path to A6 template code subdirectory
//path "F:\\Programme\\Programmierung\\A6\\Work2\\Kopie von PONG\\SOUNDS";	// Path to PONG SOUNDS



/////////////////////////////////////////////////////////////////////////////

font alien18_font = <alien18.pcx>, 25, 19;

bmap splashmap = <splashsc_PongA6.pcx>; // Logo & Pong Information splashmap
panel splashscreen { bmap = splashmap; }


/////////////////////////////////////////////////////////////////
// Filename of the starting level.
string level_str  = <Game.WMB>; // give file names in angular brackets
string level_str1 = <Level1.WMB>; 
string level_str2 = <Level2.WMB>;
string level_str3 = <Level3.WMB>;


////////////////////////////////////////////////////////////////////////////
// Included files & Function dekl.



include <Defines.wdl>;
include <Material.wdl>;
include <Laser.wdl>;

Function Spielmenue();
Function Schlaeger_Event();
Function BallEvent();
Function function_BrickDelete();

include <Pcle.wdl>;
//include <Intro.wdl>;
//include <Menue.wdl>;
include <player.wdl>;
include <PDoor.wdl>;






/////////////////////////////////////////////////////////////////
// Desc: The main() function is started at game start
function main()
{
	
	BRICKS_i = 0;
	BRICKS_LIVE_i = 0;
	

	splashscreen.visible = on;
	wait(40);
	
	// set some common flags and variables
	// freeze all entity functions
	freeze_mode = 1;
	// no level has been loaded yet...
	//gid01_level_state = gid01_level_not_loaded;

// entry: Warning Level (0,1, or 2)
// entry_help: Sets sensitivity to warnings (0 = none, 1 = some, 2 = all).
	warn_level = 2;	// announce bad texture sizes and bad wdl code
   
   
// entry: Starting Mouse Mode (0, 1, or 2)
	mouse_mode = 0;

	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	splashscreen.visible = off;
	bmap_purge(splashmap); // remove splashscreen from video memory


   // now load the level
	IF(LEVEL_LOADING == 0) { level_load(level_str);  PlLIVES = 3; 	}
	IF(LEVEL_LOADING == 1) { level_load(level_str1); PlLives = 3; BRICKS_LEVEL_CHANGE = 1;	}
	IF(LEVEL_LOADING == 2) { level_load(level_str2); BRICKS_LEVEL_CHANGE = 1;	}
	IF(LEVEL_LOADING == 3) { level_load(Level_str3); BRICKS_LEVEL_CHANGE = 1;	}


	wait(2);	// let level load
	// level should be loaded at this point...



	//gid01_level_state = gid01_level_loaded;

	//+++ load starting values


	// un-freeze the game
	freeze_mode = 0;

	// main game loop
		
	while(1)
	{
	
	
	
	
	
	/*	if(gid01_level_state != gid01_level_loaded)
		{
			freeze_mode = 1;  // pause the game
			while(gid01_level_state != gid01_level_loaded) { wait(1); }
			freeze_mode = 0;  // resume the game
		}
		
		*/
		
		
		wait(1);
	}

}









// Desc: this is the function used to restart the game.
function	main_restart_game()
{
	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// freeze the game
	freeze_mode = 1;

	if( game_load("start",0) <= 0)
	{
		diag("\nWARNING! main_restart_game - Cannot load 'start' of level.");
	}
	else
	{
		
		
		diag("\nWDL: main_restart_game - Game 'start' loaded");
	}

	// un-freeze the game
	freeze_mode = 0;
}






// Desc: this is the function used to quit the game.
function	main_quit()
{
//+++			// save global skills & strings
	exit;
}




starter check_level()
{
	while (1)
	{
		
		Spielmenue();
	
		IF(KEY_CUU == 1) 	{ MenueN -= 1; wait(12);	}
		IF(KEY_CUD == 1) 	{ MenueN += 1; wait(12);	}
		
		MenueN %=4;
		
		
	
	
	
		
		if (level_loading == 0 && Key_L != 0 || MenueN == 0 && SpielmenueStatus == 1 && KEY_ENTER == 1) 
		{
			SpielmenueStatus = 0;
						
			wait(12);
			level_loading = 1;
			freeze_mode = 1; // stop the game			
				
			
				
				
		//	freeze_mode = 0; // resume the game
			main();
		}
	
	
	
		if (level_loading == 1 && BRICKS_LEVEL_CHANGE <= 0 || level_loading == 1 &&  KEY_L != 0) 
		{
			wait(12);
			
			BRICKS_LEVEL_CHANGE = 1;
			level_loading = 2;
			freeze_mode = 1; // stop the game			
				
				PlLives += 1;
				
		//	freeze_mode = 0; // resume the game
			main();
		}
	
	
		if (level_loading == 2 && BRICKS_LEVEL_CHANGE <= 0 || PlLives < 0 || level_loading == 2 && KEY_L != 0) 
		{
			wait(12);
			
			BRICKS_LEVEL_CHANGE = 1;
			level_loading = 3;
			freeze_mode = 1; // stop the game			
				
				PlLives += 1;
				
		//	freeze_mode = 0; // resume the game
			main();
		}
		
	
		
			if (level_loading == 3 && BRICKS_LEVEL_CHANGE <= 0 || PlLives < 0 || level_loading == 3 && KEY_L != 0) 
		{
			wait(12);
			
			SpielmenueStatus = 1;
			BRICKS_LEVEL_CHANGE = 1;
			level_loading = 0;
			freeze_mode = 1; // stop the game			
				
				PlLives += 1;
				
		//	freeze_mode = 0; // resume the game
			main();
		}
		
		
		
	
		wait (1);
	}
}








/*
panel MENUE_pan 
{
	bmap = Menue_pcx;
	pos_x = 150;
	pos_y = 200;
	layer = 25;
	flags = overlay, refresh;
}
*/


panel START_pan 
{
	bmap = Start_pcx;
	pos_x = 300;
	pos_y = 300;
	layer = 26;
	flags = overlay, refresh;
}


panel OPTIONS_pan 
{
	bmap = options_pcx;
	pos_x = 300;
	pos_y = 400;
	layer = 26;
	flags = overlay, refresh;
}


panel CREDITS_pan 
{
	bmap = credits_pcx;
	pos_x = 300;
	pos_y = 500;
	layer = 26;
	flags = overlay, refresh;
}


panel EXIT_pan 
{
	bmap = exit_pcx;
	pos_x = 300;
	pos_y = 600;
	layer = 26;
	flags = overlay, refresh;
}



panel DEMO_pan 
{
	bmap  = demo_pcx;
	pos_x = 1000;
	pos_y = 900;
	layer = 26;
	flags = overlay, refresh;
}







Function Spielmenue()
{
	//SpielmenueStatus = 1;
	
	
	
	While(SpielmenueStatus == 1){
		
		
		
		//Menue_pan.visible 	= off;		//da es mir optisch nicht gefllt, habe ich auf einen Menuehintergrund verzichtet
		Start_pan.visible 	= on;			
		options_pan.visible 	= on;
		credits_pan.visible 	= on;
		exit_pan.visible 		= on;
		DEMO_pan.visible		= on;
				
		
		IF(MenueN == 0) { 
		
		Start_pan.transparent 		= off;			
		options_pan.transparent 	= on;
		credits_pan.transparent 	= on;
		exit_pan.transparent 		= on;
		
			}
		
		IF(MenueN == 1) {
		Start_pan.transparent 		= on;			
		options_pan.transparent 	= off;
		credits_pan.transparent 	= on;
		exit_pan.transparent 		= on;
		}
		
			IF(MenueN == 2) {
		Start_pan.transparent 		= on;			
		options_pan.transparent 	= on;
		credits_pan.transparent 	= off;
		exit_pan.transparent 		= on;
		}
		
		
		IF(MenueN == 3) {
		Start_pan.transparent 		= on;			
		options_pan.transparent 	= on;
		credits_pan.transparent 	= on;
		exit_pan.transparent 		= off;
		}
		
		
		IF(MenueN == 3 && KEY_ENTER == 1) {
		exit;
		}
		
		
		
		
		wait(1);
	}
		
		
		//Menue_pan.visible 	= off;		//da es mir optisch nicht gefllt, habe ich auf einen Menuehintergrund verzichtet
		Start_pan.visible 	= off;			
		options_pan.visible 	= off;
		credits_pan.visible 	= off;
		exit_pan.visible 		= off;
		
	
}











